config/routes.rb
Rails.application.routes.draw do
  resources :comments
  resources :tasks
  resources :projects
  resources :students
  resources :teachers
  resources :appoitments
  resources :patients
  resources :doctors
  #get 'movies/index'
  resources :movies
  resources :books
  resources :authors
  resources :employees
  root "authors#index"
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/appoitment.rb
class Appoitment < ApplicationRecord
  belongs_to :doctor
  belongs_to :patient
end

app/models/author.rb
class Author < ApplicationRecord
	has_many :books
end

app/models/book.rb
class Book < ApplicationRecord
  belongs_to :author
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :commentable, polymorphic: true
end

app/models/doctor.rb
class Doctor < ApplicationRecord
	has_many :appoitments
	has_many :patients,through: :appoitments
end

app/models/employee.rb
class Employee < ApplicationRecord
end

app/models/movie.rb
class Movie < ApplicationRecord
end

app/models/patient.rb
class Patient < ApplicationRecord
	has_many :appoitments
	has_many :doctors,through: :appoitments
end

app/models/project.rb
class Project < ApplicationRecord
	has_many :comments, as: :commentable
end

app/models/student.rb
class Student < ApplicationRecord
	has_and_belongs_to_many :teachers
end

app/models/task.rb
class Task < ApplicationRecord
	has_many :comments, as: :commentable
end

app/models/teacher.rb
class Teacher < ApplicationRecord
	has_and_belongs_to_many :students
end

app/controllers/teachers_controller.rb
class TeachersController < ApplicationController
  before_action :set_teacher, only: [:show, :edit, :update, :destroy]

  # GET /teachers
  # GET /teachers.json
  def index
    @teachers = Teacher.all
  end

  # GET /teachers/1
  # GET /teachers/1.json
  def show
  end

  # GET /teachers/new
  def new
    @teacher = Teacher.new
  end

  # GET /teachers/1/edit
  def edit
  end

  # POST /teachers
  # POST /teachers.json
  def create
    @teacher = Teacher.new(teacher_params)

    respond_to do |format|
      if @teacher.save
        format.html { redirect_to @teacher, notice: 'Teacher was successfully created.' }
        format.json { render :show, status: :created, location: @teacher }
      else
        format.html { render :new }
        format.json { render json: @teacher.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /teachers/1
  # PATCH/PUT /teachers/1.json
  def update
    respond_to do |format|
      if @teacher.update(teacher_params)
        format.html { redirect_to @teacher, notice: 'Teacher was successfully updated.' }
        format.json { render :show, status: :ok, location: @teacher }
      else
        format.html { render :edit }
        format.json { render json: @teacher.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /teachers/1
  # DELETE /teachers/1.json
  def destroy
    @teacher.destroy
    respond_to do |format|
      format.html { redirect_to teachers_url, notice: 'Teacher was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_teacher
      @teacher = Teacher.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def teacher_params
      params.require(:teacher).permit(:name)
    end
end

app/helpers/authors_helper.rb
module AuthorsHelper
end

app/helpers/books_helper.rb
module BooksHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/doctors_helper.rb
module DoctorsHelper
end

app/helpers/movies_helper.rb
module MoviesHelper
end

app/helpers/patients_helper.rb
module PatientsHelper
end

app/helpers/projects_helper.rb
module ProjectsHelper
end

app/helpers/students_helper.rb
module StudentsHelper
end

app/helpers/tasks_helper.rb
module TasksHelper
end

app/helpers/teachers_helper.rb
module TeachersHelper
end

app/views/teachers/_form.html.erb
<%= form_with(model: teacher, local: true) do |form| %>
  <% if teacher.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(teacher.errors.count, "error") %> prohibited this teacher from being saved:</h2>

      <ul>
      <% teacher.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name, id: :teacher_name %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/teachers/edit.html.erb
<h1>Editing Teacher</h1>

<%= render 'form', teacher: @teacher %>

<%= link_to 'Show', @teacher %> |
<%= link_to 'Back', teachers_path %>

app/views/teachers/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Teachers</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @teachers.each do |teacher| %>
      <tr>
        <td><%= teacher.name %></td>
        <td><%= link_to 'Show', teacher %></td>
        <td><%= link_to 'Edit', edit_teacher_path(teacher) %></td>
        <td><%= link_to 'Destroy', teacher, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Teacher', new_teacher_path %>

app/views/teachers/new.html.erb
<h1>New Teacher</h1>

<%= render 'form', teacher: @teacher %>

<%= link_to 'Back', teachers_path %>

app/views/teachers/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @teacher.name %>
</p>

<%= link_to 'Edit', edit_teacher_path(@teacher) %> |
<%= link_to 'Back', teachers_path %>